;   program dialog interface for rectangular array

;   1) Unlike the standard way , objects can be selected by window , crossing
;      window polygon , crossing polygon , etc.
;   2) Entries once made can be changed at will 
;      before the command is executed.
;   3) Last used valued are displayed as defaults.   



(defun c:DDRA (/ I_CARD VALIDATE RESTORE WHAT_NOW 
		 BM SRA )
	       
	      
(defun VALIDATE (/ MARK TILE_KEY)
(cond
(( = RA_COL nil) (setq MARK T TILE_KEY "no_col"))
(( = RA_ROW nil) (setq MARK T TILE_KEY "no_row"))
(( = DI_COL nil) (setq MARK T TILE_KEY "d_col"))
(( = DI_ROW nil) (setq MARK T TILE_KEY "d_row"))
(( /= (numberp RA_ROW) T ) (setq MARK T))
(( /= (numberp RA_COL) T ) (setq MARK T))
(( /= (numberp DI_ROW) T ) (setq MARK T))
(( /= (numberp DI_COL) T ) (setq MARK T))
(  T  (setq MARK nil) (RESTORE))
)

(if (= MARK T)
(progn
(set_tile "error" "Input Error - Entry Invalid")
(mode_tile TILE_KEY 2)
))
)

(defun RESTORE () (set_tile "error" ""))

(setq CE (getvar "cmdecho"))
(setq BM (getvar "blipmode"))
(setvar "cmdecho" 0)
(setvar "blipmode" 0)

(setq SRA (ssget))
(setq I_CARD (load_dialog "ddra.dcl"))
(if (not (new_dialog "ddra" I_CARD)) (exit))

(if (not RA_ROW) (setq RA_ROW 1))
(if (not RA_COL) (setq RA_COL 1))
(if (not DI_ROW) (setq DI_ROW 1))
(if (not DI_COL) (setq DI_COL 1))

(set_tile "no_row" (rtos RA_ROW 2 0))
(set_tile "no_col" (rtos RA_COL 2 0))
(set_tile "d_row" (rtos DI_ROW 2 4))
(set_tile "d_col" (rtos DI_COL 2 4))

(action_tile "no_row"
"(setq RA_ROW (distof $value 4)) (VALIDATE)")
(action_tile "no_col"
"(setq RA_COL (distof $value 4)) (VALIDATE)")
(action_tile "d_row"
"(setq DI_ROW (distof $value 4)) (VALIDATE)")
(action_tile "d_col"
"(setq di_COL (distof $value 4)) (VALIDATE)")

(action_tile "accept" "(done_dialog 4)")
(action_tile "cancel" "(done_dialog 0)")

(setq WHAT_NOW (start_dialog))
(unload_dialog I_CARD)
(if (= WHAT_NOW 4)
(progn
(setq NR (abs (fix RA_ROW)) NC (abs (fix RA_COL)))
(command "array" SRA "" "r" NR NC DI_ROW DI_COL)

)
)

(setvar "cmdecho" CE)
(setvar "blipmode" BM)
(princ)
)

;    ***** more programs in programs.lsp , ddpa.lsp ***
